#ifndef _CODETOOL_H
#define _CODETOOL_H

#include <string>
#include <map>
#include "RobotXMLFile.h"

class Robot;


typedef std::vector<long> stack_v;


class CodeTool
{
public:
	CodeTool(RobotXMLFile& ref);
	~CodeTool();
	void SetRobot(Robot *x) { m_robot = x; }
	bool Sane();
	void Call(const std::string& method);

	int GetOpsize(unsigned char op) { return m_opsize[op]; }
	const std::string& GetOpcode(unsigned char op) { return m_opcode[op]; }
	unsigned char GetCode(int ptr) { return (ptr >= 0 && ptr < (int)m_codesize) ? m_code[ptr] : 0; }
	size_t GetCodesize() { return m_codesize; }
	const unsigned char *GetBuf() { return m_code; }

	// code runner
	unsigned char Execute();
	void Jump(short);
	long get_property(int,int);
	void set_property(int,int,long);
	long call_method(int,int);

private:
	RobotXMLFile& m_config;
	Robot *m_robot;
	size_t m_codesize;
	unsigned char *m_code;
	std::map<std::string,int> m_methodmap;
	std::string m_opcode[256];
	int m_opsize[256];
	std::vector<VARIABLE *> m_variables;

	// code runner
	size_t m_ptr; // current code ptr
	long m_register1;
	long m_register2;
	stack_v m_stack;
	std::vector<MapObject *> * m_loop;
	std::vector<MapObject *>::iterator m_loop_iterator;
	bool m_loop_init;
};




#endif // _CODETOOL_H
