//#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <Utility.h>
#include <Uid.h>
#include "RowoHandler.h"
#include "InjectSocket.h"




InjectSocket::InjectSocket(ISocketHandler& h)
:HTTPSocket(h)
,m_is_server(false)
,m_content_length(0)
,m_file(NULL)
{
}


InjectSocket::~InjectSocket()
{
	if (m_file)
		fclose(m_file);
}


void InjectSocket::OnConnect()
{
	struct stat st;
	if (stat(m_filename.c_str(),&st) == -1)
	{
		Handler().LogError(this, "stat", errno, strerror(errno), LOG_LEVEL_FATAL);
		SetCloseAndDelete();
		return;
	}
	std::string request;
	request += "PUT " + m_filename + " HTTP/1.0\n";
	request += "Content-type: text/xml\n";
	request += "Content-length: " + Utility::l2string(st.st_size) + "\n";
	request += "Connection: close\n";
	request += "\n";
	Send( request );
	FILE *fil;
	if ((fil = fopen(m_filename.c_str(),"rb")) != NULL)
	{
		char buf[1000];
		size_t n;
		while ((n = fread(buf,1,1000,fil)) > 0)
		{
			SendBuf(buf, n);
		}
		fclose(fil);
	}
}


void InjectSocket::OnAccept()
{
	m_is_server = true;
}


void InjectSocket::OnFirst()
{
}


void InjectSocket::OnHeader(const std::string& key,const std::string& value)
{
//	printf("%s: %s\n",key.c_str(),value.c_str());
	if (!strcasecmp(key.c_str(),"content-type"))
	{
		if (strcasecmp(value.c_str(),"text/xml"))
		{
			Handler().LogError(this, "OnHeader", 0, "content-type not text/xml", LOG_LEVEL_FATAL);
			SetCloseAndDelete();
		}
		else
			m_filename = GetUrl();
	}
	else
	if (!strcasecmp(key.c_str(),"content-length"))
	{
		m_content_length = atoi(value.c_str());
	}
}


void InjectSocket::OnHeaderComplete()
{
//	printf("\n");
	if (m_filename.size() && m_is_server)
	{
		Uid random;
		m_filename = random.GetUid() + ".xml";
		m_file = fopen(m_filename.c_str(),"wb");
	}
}


void InjectSocket::OnData(const char *buf,size_t sz)
{
//	printf("%s",static_cast<std::string>(buf).substr(0,sz).c_str());
	if (m_file)
		fwrite(buf,1,sz,m_file);
//printf("content length is still %d bytes, received %d bytes\n",m_content_length,sz);
	m_content_length -= sz;
	if (m_content_length <= 0)
	{
		fclose(m_file);
		m_file = NULL;
		SetCloseAndDelete();
		static_cast<RowoHandler&>(Handler()).InjectRobot(m_filename);
		unlink(m_filename.c_str());
	}
}


