#ifndef _INJECTSOCKET_H
#define _INJECTSOCKET_H

#include <HTTPSocket.h>
#include <ISocketHandler.h>


class InjectSocket : public HTTPSocket
{
public:
	InjectSocket(ISocketHandler& h);
	~InjectSocket();

	void OnConnect();
	void OnAccept();

	void SetFilename(const std::string& x) { m_filename = x; }

	void OnFirst();
	void OnHeader(const std::string&,const std::string&);
	void OnHeaderComplete();
	void OnData(const char *,size_t);

private:
	bool m_is_server;
	std::string m_filename;
	int m_content_length;
	FILE *m_file;
};




#endif // _INJECTSOCKET_H
