#ifndef _RADAR_H
#define _RADAR_H

#include "RobotObject.h"
#include "MapObject.h"
#include "CodeTool.h"

class Map;


class Radar : public RobotObject
{
	struct SCAN {
		SCAN(MapObject *p,int r,int d) : m_object(p),m_relative_angle(r),m_distance(d) {}
		MapObject *m_object;
		int m_relative_angle;
		int m_distance;
	};
	typedef std::vector<SCAN *> scan_v;
public:
	Radar(Robot&);
	~Radar();

	void Tick(long usec);

	long get_property(int);
	void set_property(int,long);
	long call_method(int,stack_v&);

	// methods
	void Scan( Map& ,int distance ); // scan time = power / distance

	// set properties
	void SetMaxPower(int x) { m_max_power = x; }
	void SetMaxDistance(int x) { m_max_distance = x; }
	void SetChargeSpeed(int x) { m_charge_speed = x; }
	
	// get properties
	int GetMaxPower() { return m_max_power; }
	int GetMaxDistance() { return m_max_distance; }
	int GetPower() { return m_power; }
	int GetChargeSpeed() { return m_charge_speed; }
	scan_v& GetScanlist() { return m_scanlist; }

private:
	// properties
	int m_max_power;
	int m_max_distance;
	int m_power;
	int m_charge_speed; // units/sec
	scan_v m_scanlist;
};


#endif // _RADAR_H
